#include "p24fj48ga002.h"
#include<string.h>
#include <stdio.h>
#include "I2C.h"
#include"main.h"

void InitADC(void) 
{
	///configure PORTS to be scanned
	//TRISBbits.TRISB3 = 1;      // Set RB3 to Input
	TRISAbits.TRISA0 = 1;		// Set RA0 to Input
	TRISAbits.TRISA1 = 1;		// Set RA1 to Input
	TRISBbits.TRISB12 = 1;		// Set RB12 as Input
	TRISBbits.TRISB13 = 1;		// Set RB13 as Input

	AD1PCFG = 0xE7FC;         // Clear Bit-0; Bit-1 and Bit-12, Set all others. Only AN5 is Analog

	AD1CSSLbits.CSSL0 = 1;
	AD1CSSLbits.CSSL1 = 1;
	AD1CSSLbits.CSSL12 = 1;
	AD1CSSLbits.CSSL11 = 1;
	
	//Set Channel 0, positive input to pin5 and negative input to Vr-
  	AD1CHS = 0;                // clear AD1CHS
	AD1CHSbits.CH0SA = 5;      // MUX-A Positive Input is AN5; This is the input port to the AtoD


	AD1CON3bits.ADCS = 255;   // select the analog conversion clock

	//Select the appropriate sample/conversion sequence
	AD1CON3bits.SAMC = 31;     // Auto conversion time = 12 x TAD
	AD1CON1bits.SSRC = 7;      // Internal counter ends sampling and starts conversion (auto-convert)

	//Select the analog conversion clock
	AD1CON3bits.ADRC = 0;      // Clock derived from system clock

	//Select voltage reference source
	//Select the interrupt rate
	AD1CON2 = 0;               // Clear the A/D Control Register 2; Sets Vr+ to AVdd and Vr- to AVss

                              // Do not scan inputs

                              // Interrupts at the completion of conversion for each sample/convert sequence

                              // Buffer configured as one 16-word buffer (AD1BUFn<15:0>)

                              // Always uses MUX A input multiplexer settings

	AD1CON2bits.SMPI = 15; //NO MORE THAN 8 CONVERSIONS PER INTERRUP WHEN BUFM IS SET
	//AD1CON3bits.ADCS = 255;



	AD1CON2bits.CSCNA = 1; //scans inputs for the MUXA

	AD1CON1bits.ASAM = 1;      // Sampling begins immediately after last conversion completes. SAMP bit is auto-set.

	//Select how conversion results are presented in the buffer
	AD1CON1bits.FORM = 0;      // Data format = simple 10-bit integer

	AD1CON1bits.ADSIDL = 1;    // Stop in Idle Mode

	AD1CON1bits.ADON = 1;      // ADC Module is Enabled
	
	//Interrupt configuration
	IPC3bits.AD1IP = 1;        // select A/D interrupt priority
	IFS0bits.AD1IF = 0;        // clear interrupt flag 
	IEC0bits.AD1IE = 1;        // enable ADC1 interrupt   

   AD1CON1bits.SAMP = 1;      // Sampling begins 

}
//ADC1 interrupt routine
  
void __attribute__((interrupt, no_auto_psv)) _ADC1Interrupt(void) {

	if (ADCskip >= 25)
	{	
		if( ADC_Mag1_F==0 || ADC_Mag2_F==0 || ADC_Dist_F==0)
		{
			ADC_Mag1 = ADC1BUF0; // first sample, on pin0
			//ADC_Mag1 = 10;
			ADC_Mag1_F = 1;
			
			ADC_Mag2 = ADC1BUF1; // second sample, on pin1
			ADC_Mag2_F = 1;
			
			ADC_Dist = C2cm(ADC1BUF2); // third sample, on pin24
			//ADC_Dist = 1;
			ADC_Dist_F = 1;

			ADC_Dist2 = C2cm(ADC1BUF3); // third sample, on pin23
			//ADC_Dist = 1;
			ADC_Dist2_F = 1;
		}
			
		ADCskip = 0;
	}
	else
	{
		ADCskip++;
	}
	
	
	
	IFS0bits.AD1IF = 0; // clear interrupt flag
} 
