#define AUX_FUNC_C

#include "aux_func.h"
#include "UART.h"
#include "main.h"

void wait (int t2w)
{
	unsigned int i, j;
	
	for(j=0; j<t2w; j++)
	{
		for (i=0;i<65535;i++)
		{
			
		}
	}

}

int C2V (int ADCval)
{
	int mV;
	
	mV = (3270/1024)*ADCval; //mV 
	return mV;
}

int C2cm (int ADCval)
{
	int mV, cm;
	
	mV = (3270/1024)*ADCval; //mV 
	
	cm = mV / 2,5 ; // Scaling factor (VCC/512) per inch -> 2,5mV/cm
	
	return cm;
}

double Azimuth ( int ADCX, int ADCY)
{
	int x, y;
	double az_temp;
	
	x = ADCX - 512 + 22;
	y = ADCY - 512;
	
//	if (x == 0)
//	{
//		if (y > 0)
//		{
//			az_temp = 90;
//		}
//		else
//		{
//			az_temp = 270;
//		}
//	}
//	
//	if (x > 0)
//	{
//		if (y > 0)
//		{
//			az_temp = (360 - atan2(y, x)*(180/3.1416));
//		}
//		else
//		{
//			az_temp = ((-1)*atan2(y, x)*(180/3.1416));
//		}
//	}
//	
//	if(x < 0)
//	{
//		az_temp = (180 - atan2(y, x)*(180/3.1416));
//	}

	az_temp = atan2(y,x)*(180/3.1416);
	
	return az_temp;
}	

void data_decoder (char *data_string)
{
	//TX2("gps.lat DATA_ini- %s\n",gps->lat);
	//gps->lat="string inicial";
	
	char header[7];
	int pos;
	char key[]=",";
	char * pEnd;
	int i=0;
	
	int Checksum_ref, Checksum_act;
	
	///reference value to Checksum
	Checksum_ref = ReadChecksum(data_string);
	
	///actual value of the Checksum, for the string recieved
	Checksum_act = CalcChecksum(data_string);
	
	
	///only updates the data if the Checksum calculates matches the reference
	if( Checksum_ref == Checksum_act)
	{
		///number of characters of data_string readed before this first ','
		pos = strcspn(data_string,key);
		
		///copies the first (pos) characters of data_string to header
		strncpy(header, data_string, pos);
		////TX2("\n");
		////TX2("%s\n", header);
		
		///Geographic Position - Latitude/Longitude
		if ( (strncmp(header, "$GPGLL", 6)) == 0)
		{
			////TX2("\nGLL\n");

			
			while(data_string[i++] != ','); //skips the header
			gps->lat = strtod(&data_string[i], &pEnd);
			
			while(data_string[i++] != ','); //jumps to NS indicator
			gps->NSi = data_string[i];
			
			while(data_string[i++] != ','); //jumps to Longitude field 
			gps->lon = strtod(&data_string[i], &pEnd);// * 10000) + 8670455)/64.457364;
			
			while(data_string[i++] != ','); //skips to WE indicator
			gps->WEi = data_string[i];
				
			while(data_string[i++] != ','); // read next field 
			gps->UTC = strtod(&data_string[i], &pEnd) + 10000; // add 10000 (+1h), to adjust UTC to summer time.
			
			////TX2("->%s<-\n",data_string);
			
			//TX2("Latitude - %.4lf\n",gps->lat);
			//TX2("Reference (N/S) - %c\n",gps->NSi);
			//TX2("Longitude - %.4lf\n",gps->lon);
			//TX2("Reference (W/E) - %c\n",gps->WEi);
			//TX2("UTC time - %6.3lf\n",gps->UTC);
			
			//kill(pid,SIGUSR2);
		}
		
		if (strncmp(header, "$GPGGA", 6) == 0)
		{
			////TX2("\nGPGGA\n");
			i=0;
			
			while(data_string[i++] != ','); //skips the header
			while(data_string[i++] != ','); //jumps to Latitude field
			while(data_string[i++] != ','); //jumps to NS indicator field
			while(data_string[i++] != ','); //jumps to Longitude field
			while(data_string[i++] != ','); //jumps to WE indicator field
			
			while(data_string[i++] != ','); //jumps to WE indicator field
			gps->pos_fix = strtod(&data_string[i], &pEnd);
			
			while(data_string[i++] != ','); //jumps to WE indicator field
			gps->n_sat = strtod(&data_string[i], &pEnd);
			
			while(data_string[i++] != ','); //jumps to WE indicator field
			gps->HDOP = strtod(&data_string[i], &pEnd);
			
			while(data_string[i++] != ','); //jumps to WE indicator field
			gps->alt = strtod(&data_string[i], &pEnd);
			
			////TX2("->%s<-\n",data_string);
			//TX2("Position fix - %.1lf\n",gps->pos_fix);
			//TX2("Number os satellites in sigth - %.1lf\n",gps->n_sat);
			//TX2("HDOP - %.4lf\n",gps->HDOP);
			//TX2("Altitude - %.1lf (M)\n",gps->alt);
		}
		if (strncmp(header, "$GPRMC", 6) == 0)
		{
			////TX2("\nGPRMC\n");
			i=0;
			
			while(data_string[i++] != ','); //skips the header
			//while(data_string[i++] != ','); //jumps to UTC field
				
			while(data_string[i++] != ','); //jumps to NS indicator field
			gps->nav_w = data_string[i];
			
			while(data_string[i++] != ','); //jumps to Latitude field
			while(data_string[i++] != ','); //jumps to NS indicator field
			while(data_string[i++] != ','); //jumps to Longitude field
			while(data_string[i++] != ','); //jumps to WE indicator field
				
			while(data_string[i++] != ','); //jumps to Speed over ground field
			gps->speed = strtod(&data_string[i], &pEnd);
			
			while(data_string[i++] != ','); //jumps to Course Made good field
			while(data_string[i++] != ','); //jumps to Date field
			gps->date = strtod(&data_string[i], &pEnd);
			
			////TX2("->%s<-\n",data_string);
			//TX2("Nav Warning A=OK - %c\n",gps->nav_w);
			//TX2("Data - %.1lf\n",gps->date);
			
		}
		if (strncmp(header, "$GPGSA", 6) == 0)
		{
			////TX2("\nGPGSA\n");
			i=0;
			
			while(data_string[i++] != ','); //skips the header
			while(data_string[i++] != ','); //jumps to Latitude field
			gps->dim = strtod(&data_string[i], &pEnd);
			
			while(data_string[i++] != ','); //jumps to Sat1 field
			while(data_string[i++] != ','); //jumps to Sat2 field
			while(data_string[i++] != ','); //jumps to Sat3 field
			while(data_string[i++] != ','); //jumps to Sat4 field
			while(data_string[i++] != ','); //jumps to Sat5 field
			while(data_string[i++] != ','); //jumps to Sat6 field
			while(data_string[i++] != ','); //jumps to Sat7 field
			while(data_string[i++] != ','); //jumps to Sat8 field
			while(data_string[i++] != ','); //jumps to Sat9 field
			while(data_string[i++] != ','); //jumps to Sat10 field
			while(data_string[i++] != ','); //jumps to Sat11 field
			while(data_string[i++] != ','); //jumps to Sat12 field
				
			while(data_string[i++] != ','); //jumps to PDOP field
			gps->PDOP = strtod(&data_string[i], &pEnd);
			while(data_string[i++] != ','); //jumps to HDOP field
			while(data_string[i++] != ','); //jumps to VDOP field
			gps->VDOP = strtod(&data_string[i], &pEnd);
			
			//TX2("->%s<-\n",data_string);
			//TX2("Solucao_Qualidade (2D/3D) - %.1lf\n",gps->dim);
			//TX2("PDOP - %.4lf\n",gps->PDOP);
			//TX2("VDOP - %.4lf\n",gps->VDOP);
		}
		if (strncmp(header, "$GPGSV", 6) == 0)
		{
			////TX2("\nGPGSV\n");
			
		}
		
		if (strncmp(header, "$PMGNST", 7) == 0)
		{
			////TX2("\nPMGNST\n");
			i=1;
			
			while(data_string[i++] != ','); //skips the header
			gps->softver = strtod(&data_string[i], &pEnd);
			
			while(data_string[i++] != ',');
			while(data_string[i++] != ','); // Have solution
			gps->have_fix = data_string[i];
			
			while(data_string[i++] != ','); //skips to battery status field
			gps->bat_left = strtod(&data_string[i], &pEnd);
			
			while(data_string[i++] != ','); //skips to battery status field
			gps->bat_hour = strtod(&data_string[i], &pEnd);
		
			////TX2("->%s<-\n",data_string);
			//TX2("Have solution? - %c\n",gps->have_fix);
			//TX2("Software version - %.2lf\n",gps->softver);
			//TX2("Battery percentage - %.1lf \n", gps->bat_left);
			//TX2("Battery remaining - %.2lf (hours)\n\n\n",gps->bat_hour);
			
			//kill(pid,SIGUSR2);
		}
		
		//kill(pid,SIGUSR2);
		////TX2("sinal enviado\n");
		
		////TX2("gps.lat DATA_end- %s\n",gps->lat);
		//t2w(2000);
	}
	else
	{
	
	}
	
}

int CalcChecksum(char* str)
{
	unsigned char Character;
	unsigned int Checksum = 0;
	int i, length;

	length = strlen(str);

	 if  (strlen(str) ==  0 )  return   0 ;

	///read and estimate the Sum value
	for(i=0;i<length;i++)
	{
		Character = str[i];

		if (Character == '$')
		{
			// Ignore the dollar sign
		}
		else if (Character == '*')
		{
			// Stop processing before the asterisk
			break;
		}
		else
		{
		Checksum ^= Character; ///< exectutes the XOR operations between the characters limited by '$' and '*'
		}
	} 
	
	////TX2("A soma deu %d\n", Checksum);
	return Checksum;
}


/*! \fn ReadChecksum(char *str)
    \brief This function reads the Checksum value, this will be the reference to validate the sentence. 
    \param *str the sentence recieved.
    \return the int value of the Checksum readed
*/
int ReadChecksum(char *str)
{
	int hex_pos, hex_1, hex_0, Checksum_val;
	char key_end[]="*";
	char *temp;
	
	
	///number of characters of data_string read before this first ','
	hex_pos = strcspn(str, key_end) + 1;
	
	////TX2("primeiro%c ", str[hex_pos] );
	////TX2("segundo%c \n", str[hex_pos + 1] );
	
	///copies the first (pos) characters of data_string to header
	//strncpy(temp, str, hex_pos);
	temp=&str[hex_pos];
	////TX2("temp = %c ", *temp);
	
	///interpretation of the frist hex character
	switch (*temp)
	{	
		case 'A':
			hex_1= 10;
			break;
		case 'B':
			hex_1= 11;
			break;
		case 'C':
			hex_1= 12;
			break;
		case 'D':
			hex_1= 13;
			break;
		case 'E':
			hex_1= 14;
			break;
		case 'F':
			hex_1= 15;
			break;
		default:
			hex_1= *temp-48;
	}

	temp=&str[hex_pos + 1];
	////TX2("temp2 = %c ", *temp);
	///interpretation of the second hex character
	switch (*temp)
	{	
		case 'A':
			hex_0= 10;
			break;
		case 'B':
			hex_0= 11;
			break;
		case 'C':
			hex_0= 12;
			break;
		case 'D':
			hex_0= 13;
			break;
		case 'E'://
			hex_0= 14;
			break;
		case 'F':
			hex_0= 15;
			break;
		default:
			hex_0= *temp-48;
	}
	
	////TX2("\n\n%d   %d\n", hex_1, hex_0);
	
	///Convert the number in hexadecimal base to decimal base
	Checksum_val = hex_1*16 + hex_0;
	
	return Checksum_val;
}
